import random
import pickle

# 手を表す定数
ROCK = 0
SCISSORS = 1
PAPER = 2
HAND = [ROCK, SCISSORS, PAPER]

# 勝敗を表す定数
DRAW = 0
USER_LOST = 1
USER_WIN = 2
USER_JUDGE = ["あいこ", "ユーザーの負け", "ユーザーの勝ち"]

# ジャンケンを1回行い、勝敗とユーザーが出した手を返す関数
def play(best_computer_hand=None):
    # ユーザーが手を選ぶ
    while True:
        # 手をキー入力する
        print("******* 手を選んでください *******")
        print(f"グー = {ROCK}, チョキ = {SCISSORS}, パー = {PAPER}")
        user_hand = input("ユーザーの手:")
        # 数字が入力されたことをチェックする
        if user_hand.isnumeric():
            user_hand = int(user_hand)
        else:
            continue
        # 手を表す数値であることをチェックする
        if user_hand in HAND:
            break

    # コンピュータが手を選ぶ
    if best_computer_hand is None:
        # 乱数で手を選ぶ
        computer_hand = random.choice(HAND)
    else:
        # 外部から引数で指定された手を設定する
        computer_hand = best_computer_hand
    # コンピュータが選んだ手を表示する
    print(f"コンピュータの手:{computer_hand}")

    # 勝敗を判定する
    judge = (user_hand - computer_hand + 3) % 3
    print(USER_JUDGE[judge])
    print()

    # 勝敗とユーザーが出した手を戻り値として返す
    return judge, user_hand

# メインプログラム
if __name__ == "__main__":
    play(None)
